//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//
// $Header: E:/simbiosys/RCS/FSM.H 1.1 1996/06/26 10:55:12 dbm Exp $
//
  
#ifndef FSM_H
#define FSM_H

#include "program.h"

/////////////////////////////////////////////////////////////////////////////
//
//	bioFSM (finite state machine program)
//
  
class bioFSM : public bioProgram
{
  public:
    ctor				bioFSM (int, int, int);
    dtor				~bioFSM (void);
    
    override void		Init (void);
  	override int		Think (int* inputVector, int size);
  	override void		ReadArray (int* array, int size);
  
  protected: 
    int           		_state;
    int                 _stateSize;
    int                 _stateMask;
    int                 _inputSize;
    int                 _inputMask;
    int                 _output;
    int                 _outputSize;
    int                 _outputMask;
    int*                _table;
    int                 _tableSize;
    int                 _index;
};

#endif // FSM_H
