//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//

#ifndef bioLIST_H
#define bioLIST_H

#include "simbio.h"

class bioNode 
{   
public:
	ctor			bioNode (bioObject*);

	friend class	bioList;
		        
protected:
	bioObject*		data;
  	bioNode*		prev;
  	bioNode*		next;
};

class bioList : public bioObject
{        
public:
   	ctor			bioList();
   	ctor			bioList (bioList&);
   	dtor			~bioList();
   	                                    
	int				Count (void); 
	int				IsEmpty (void);
	  	                                    
   	int 			Append (bioObject*);  
   	int 			Remove (bioObject*); 
   	
   	int				RemoveAll (void);  
   	int				DeleteAll (void);  
   	
   	void			First (void);
   	bioObject*		Next (void);      

   	void			Last (void);
   	bioObject*		Prev (void);      
   	 
   	int				Find (bioObject*);
   	
   	bioList&		operator= (bioList&);
   	
   	override void	AssertValid (void) const;
   	
protected:   
   	bioNode*		_Find (bioObject*);

	int				_count;
   	bioNode*		_first;
   	bioNode*		_cur;
  	bioNode*		_last;
};

#endif // bioLIST_H

