//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//
// $Header: E:/simbiosys/RCS/SIMULAT.H 1.1 1996/06/26 10:55:18 dbm Exp $
//
 
#ifndef SIMULAT_H
#define SIMULAT_H

#include "simbio.h"
#include "populat.h"
#include "world.h"

/////////////////////////////////////////////////////////////////////////////
//
//	bioSimulation
//
    
class bioSimulation : public bioObject
{
  public:
  	ctor				bioSimulation (void);
  	dtor				~bioSimulation (void);
  					
  	virtual void		SetWorld (bioWorld*);
  	virtual bioWorld*	GetWorld (void); 
  	
  	virtual void		AddPopulation (bioPopulation*);  
  	
  	virtual int			GetData (int src, void* dest);  
  	
  	virtual int			NextStep (void);
  	virtual int			StartEnvCycle (void) {return FALSE;}
  	virtual int			StartBreedCycle (void) {return FALSE;} 
  	virtual void		DoBreedCycle (void);
  	virtual void		DoEnvCycle (void);
  	virtual void		DoActionCycle (void);
  	
  protected:
    bioWorld*			_world;
    bioList				_populations;

	int					_curAct;
	int					_totalAct;  	                           	
  	int					_curEnv;  
  	int					_totalEnv;
  	int					_curGen;
};

#endif // SIMULAT_H
